=== debian/changelog ===
msgpack-cxx (7.0.0-2) unstable; urgency=medium

  * autopkgtest: Increase cmake_minimm_required version to 3.16
    (Closes: #1116513)
  * Declare compliance with Policy 4.7.2, no changes needed
  * Remove Rules-Requires-Root, no longer necessary
  * Add salsa-ci.yml and test nocheck / nodoc profiles

 -- James McCoy <jamessan@debian.org>  Wed, 01 Oct 2025 17:52:46 -0400

msgpack-cxx (7.0.0-1) unstable; urgency=medium

  * New upstream release
  * Declare compliance with Policy 4.7.0, no changes required
  * Set Homepage to cpp_master branch
  * Bump minimum cmake version to 3.5

 -- James McCoy <jamessan@debian.org>  Sat, 02 Nov 2024 18:46:06 -0400
